<!-- [QPRTemplateStart: impactanalysis.tpl] -->
<!-- Version 3.1 -->
<!DOCTYPE html>
<html>
  <head>
    <title><#LocalizedText id="Impact Analysis"></title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    
    <script type="text/javascript" src="<#ScriptFileLocation>utils.js"></script>
    <#Include template="jswsfutils.tpl">
    <script type="text/javascript" src="<#ScriptFileLocation>jquery.min.js"></script>
    <script type="text/javascript" src="<#ScriptFileLocation>jquery-ui.custom.min.js"></script>
    <script type="text/javascript" src="<#ScriptFileLocation>jquery.cookie.js"></script>
    <script type="text/javascript" src="<#ScriptFileLocation>jquery.dynatree.min.js"></script>
    <script type="text/javascript" src="<#ScriptFileLocation>../../datatables/js/jquery.dataTables.js"></script>
    <script type="text/javascript" src="<#ScriptFileLocation>../../datatables/js/FixedHeader.min.js"></script>
    <script type="text/javascript" src="<#ScriptFileLocation>jshashtable.js"></script>
    <script type="text/javascript" src="<#ScriptFileLocation>jquery.numberformatter.js"></script>

    <#stylesheet>
    <link href="<#CSSFileLocation>../datatables/css/page.css" rel="stylesheet" type="text/css" />
    <link href="<#CSSFileLocation>../datatables/css/table.css" rel="stylesheet" type="text/css" />
    <link href="<#CSSFileLocation>impactanalysis.css" rel="stylesheet" type="text/css" />
    <link href="<#CSSFileLocation>ui.dynatree.css" rel="stylesheet" type="text/css" />
 
<script type="text/javascript">

  var USE_GLOBAL_CONFIGURATION_MODEL = true;
  var REPORT_CONFIGURATION_MODEL = "PG.1089606584";
  var REPORT_CONFIGURATION_ELEMENTTYPE = "Report";
  var OUTPUT_DATE_FORMAT = 'dd.mm.yy';
  var NUMBER_FORMAT_LOCALE = "us"; //available values: http://code.google.com/p/jquery-numberformatter/
  
  var DELETED_LABEL = "<#LocalizedText id="Deleted">"; 
  var NEW_LABEL = "<#LocalizedText id="New">";
  var XML_DATE_FORMAT = 'yy-mm-dd';
  var CONFIGURATION_ATTRIBUTES = ["name", "description", "connections", "separator", "mappings", "columnwidths", "sorting", "gapanalysismatchingattribute", "gapanalysisseparatorcriteria", "rowcombiningattribute", "gapanalysisstatushighlightcolumns", "gapanalysisstatuscolumns", "columnformats", "grouping"];
  var JSON_ATTRIBUTES = ["connections", "mappings", "columnwidths", "sorting", "gapanalysisstatushighlightcolumns", "gapanalysisstatuscolumns", "columnformats", "grouping"];
  
  var REPORT_CONFIGURATION;
  var oAccessor;
  var reportData;
  var serverNode;
  var rootModelParents = Object();
  var currentPath;
  var currentPhysicalLevel;
  var currentLogicalLevel;
  var leftAttributes;
  var rightAttributes;
  var selectedReportIndex;
  var oTable;
  var oTableFixedHeader;
  var attributesToReplace;
  var attributeToReplaceIndex;
  var openPortalUrlObjectId;
  var openPortalUrlViewName;
  var openPortalUrlOptions;
  var gapAnalysisSeparatorCriteria;
  var gapAnalysisLeftObjects;
  var rowCombiningAttributeData;
  var separator;
  
  function runReport() {
    $("div#reportGenerationText").show();
    selectedReportIndex = $('select#reportNameParametersView').val();
    if (selectedReportIndex == null) {
      alert("No report is selected.");
      return;
    }
    windowResized();
    leftAttributes = new Object();
    rightAttributes = new Object();
    reportData = new Object();
    rowCombiningAttributeData = new Object();
    currentPath = -1;
    attributesToReplace = new Object();
    allAttributes = getAllAttributes();
    for (var i = 0; i < allAttributes.length; i++) {
      if (allAttributes[i].indexOf("#") > -1) {
        attributesToReplace[removeNonValidNameCharacters(allAttributes[i])] = new Object();
      }
    }
    oAccessor.AutoAuthenticate(processPath, handleError);
  }

  /*
  Handles one report path and then calls itself to process next path.
  */
  function processPath() {
    currentPath++;
    if (REPORT_CONFIGURATION[selectedReportIndex].connections.length == currentPath) {
      var combinedReportData = reportData[0];
      delete reportData[0];
      for (var item in reportData) {
        for (var item2 in reportData[item]) {
          if (combinedReportData[item2] == null) {
            combinedReportData[item2] = reportData[item][item2];
          } else {
            for (var item3 in reportData[item][item2]) {
              var itemIndex = getIndex(combinedReportData[item2], reportData[item][item2][item3].id);
              if (itemIndex == -1) {
                combinedReportData[item2].push(reportData[item][item2][item3]);
              } else {
                combinedReportData[item2][itemIndex].attributes = combinedReportData[item2][itemIndex].attributes.merge(reportData[item][item2][item3].attributes);
              }
            }
          }
        }
      }
      
      reportData = combinedReportData;
          
      var combinedLeftAttributes = Object();
      for (var item in leftAttributes) {
        for (var item2 in leftAttributes[item]) {
          combinedLeftAttributes[item2] = leftAttributes[item][item2];
        }
      }
      leftAttributes = combinedLeftAttributes;
      
      var combinedRightAttributes = Object();
      for (var item in rightAttributes) {
        for (var item2 in rightAttributes[item]) {
          combinedRightAttributes[item2] = rightAttributes[item][item2];
        }
      }
      rightAttributes = combinedRightAttributes;
      
      attributeToReplaceIndex = -1;
      getNextAttributes();
    } else { 
      currentPhysicalLevel = -1;
      leftAttributes[currentPath] = new Object();
      rightAttributes[currentPath] = new Object();
      processLevel();
    }
  }   
  
  function getIndex(arrayToSearch, searchItem) {
    for (var item = 0; arrayToSearch != null && item < arrayToSearch.length; item++) {
      if (arrayToSearch[item].id == searchItem) {
        return item;
      }
    }
    return -1;
  }
  
  function getSelectedModels() {
    var selectedModels = new Array();
    var selectedNodes = $("#tree").dynatree("getSelectedNodes");
    for (var i = 0; i < selectedNodes.length; i++) {
      if (!selectedNodes[i].data.isFolder) {
        selectedModels.push(selectedNodes[i].data.key.replace(".-1", "").replace(".-2", "").replace(".-3", "").replace(".-4", ""));
      }
    }
    return selectedModels;
  }
  
  /*
  Handles one node of a single path and call itself to handle the next node.
  */  
  function processLevel(result) {
    if (result != null) {
      var connections = new Object();
      var leftRelationNameAttributes = new AttributeCollection();
      var rightRelationNameAttributes = new AttributeCollection();
      for (var i = 0; result.ChildElements != null && i < result.ChildElements.length; i++) {
        var left = new Array();
        var right = new Array();
        var attributes = new AttributeCollection();

        for (var j = 0; result.ChildElements[i].ChildElements != null && j < result.ChildElements[i].ChildElements.length; j++) {
          var attributeName = result.ChildElements[i].ChildElements[j].Name;
          var attributeValue = result.ChildElements[i].ChildElements[j].Value;
            
          if (attributeName.substring(0, "left_".length) == "left_" && attributeValue != "") {
            attributeValue = attributeValue.split(",");
            left = left.concat(attributeValue);
            if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToPreviousAsAttribute || REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToNextAsAttribute) { //save relation names if connectionToPreviousAsAttribute or connectionToNextAsAttribute are used
              for (var index = 0; index < attributeValue.length; index++) {
                leftRelationNameAttributes.add([attributeValue[index] + "|" + result.ChildElements[i].Id], attributeName.substr("left_".length));
              }
            }
          } else if (attributeName.substring(0, "right_".length) == "right_" && attributeValue != "") {
            attributeValue = attributeValue.split(",");
            right = right.concat(attributeValue);
            if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToPreviousAsAttribute || REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToNextAsAttribute) {
              for (var index = 0; index < attributeValue.length; index++) {
                rightRelationNameAttributes.add([result.ChildElements[i].Id + "|" + attributeValue[index]], attributeName.substr("right_".length));
              }
            }
          } else if (attributeName.substring(0, "attribute_".length) == "attribute_" && currentPhysicalLevel != 0 && currentPhysicalLevel != REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath].length - 1) {
            attributes.add("level" + currentLogicalLevel + "_" + attributeName.substr("attribute_".length).replace("_hash_", "#"), attributeValue);
          } else if (attributeName == "rowcombiningattribute") {
            rowCombiningAttributeData[result.ChildElements[i].Id] = result.ChildElements[i].ChildElements[j].Value;
          }
        }
      
        if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].includeRelationToSelf != null && REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].includeRelationToSelf) {
          left.push(result.ChildElements[i].Id);
          right.push(result.ChildElements[i].Id);
        }
      
        if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToPrevious == null || REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToPrevious.length == 0) {
          left.push(result.ChildElements[i].Id);
        }
        if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToNext == null || REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToNext.length == 0) {
          right.push(result.ChildElements[i].Id);
        }
              
        var newRightObjects = new Array();
        for (var rightIndex = 0; rightIndex < right.length; rightIndex++) {
          var rightObject = new Object();
          rightObject.id = right[rightIndex];
          rightObject.attributes = attributes;
          newRightObjects.push(rightObject);
        }
        
        for (var leftIndex = 0; leftIndex < left.length; leftIndex++) {
          if (connections[left[leftIndex]] == null) {
            connections[left[leftIndex]] = new Array();
          }
          var rightObjectsCopy = new Array();
          for (var obj = 0; obj < newRightObjects.length; obj++) {
            var rightObject = new Object();
            rightObject.id = newRightObjects[obj].id;
            if (newRightObjects[obj].attributes != null) {
              rightObject.attributes = newRightObjects[obj].attributes.copy();
            }
            rightObjectsCopy.push(rightObject);
          }
          connections[left[leftIndex]] = connections[left[leftIndex]].concat(rightObjectsCopy);
        }
 
        if (currentPhysicalLevel == 0) { //store left attributes
          leftAttributes[currentPath][result.ChildElements[i].Id] = Object();
          for (var j = 0; result.ChildElements[i].ChildElements != null && j < result.ChildElements[i].ChildElements.length; j++) {
            leftAttributes[currentPath][result.ChildElements[i].Id][result.ChildElements[i].ChildElements[j].Name.substr(10).replace("_hash_", "#")] = result.ChildElements[i].ChildElements[j].Value;
          }
        } else if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath].length - 1 == currentPhysicalLevel) { //store right attributes
          rightAttributes[currentPath][result.ChildElements[i].Id] = Object();
          for (var j = 0; result.ChildElements[i].ChildElements != null && j < result.ChildElements[i].ChildElements.length; j++) {
            rightAttributes[currentPath][result.ChildElements[i].Id][result.ChildElements[i].ChildElements[j].Name.substr(10).replace("_hash_", "#")] = result.ChildElements[i].ChildElements[j].Value;
          }
        }
      }

      if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToPrevious != null && REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToPrevious.length > 0 && REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToNext != null && REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToNext.length > 0) {  //both connectionToPrevious or connectionToNext defined
        for (var leftRelationNameAttribute in leftRelationNameAttributes) {
          var leftSeparatorIndex = leftRelationNameAttribute.indexOf("|");
          var leftId = leftRelationNameAttribute.substring(0, leftSeparatorIndex);
          var leftMiddleId = leftRelationNameAttribute.substr(leftSeparatorIndex + 1);
          for (var rightRelationNameAttribute in rightRelationNameAttributes) {
            var rightSeparatorIndex = rightRelationNameAttribute.indexOf("|");
            var rightMiddleId = rightRelationNameAttribute.substring(0, rightSeparatorIndex);
            var rightId = rightRelationNameAttribute.substr(rightSeparatorIndex + 1);
            if (leftMiddleId == rightMiddleId) {
              for (var listIndex = 0; connections[leftId] != null && listIndex < connections[leftId].length; listIndex++) {
                connections[leftId][listIndex].attributes.addAll("level" + currentLogicalLevel + "_leftRelation", leftRelationNameAttributes[leftRelationNameAttribute]);
                connections[leftId][listIndex].attributes.addAll("level" + currentLogicalLevel + "_rightRelation", rightRelationNameAttributes[rightRelationNameAttribute]);
              }
            }
          }
        }
      } else { //either connectionToPrevious or connectionToNext defined
          for (var leftRelationNameAttribute in leftRelationNameAttributes) {
          var separatorIndex = leftRelationNameAttribute.indexOf("|");
          var leftId = leftRelationNameAttribute.substring(0, separatorIndex);
          var rightId = leftRelationNameAttribute.substr(separatorIndex + 1);
          for (var listIndex = 0; connections[leftId] != null && listIndex < connections[leftId].length; listIndex++) {
            if (connections[leftId][listIndex].id == rightId) {
              connections[leftId][listIndex].attributes.addAll("level" + currentLogicalLevel + "_leftRelation", leftRelationNameAttributes[leftRelationNameAttribute]);
            }
          }
        }

        for (var rightRelationNameAttribute in rightRelationNameAttributes) {
          var separatorIndex = rightRelationNameAttribute.indexOf("|");
          var leftId = rightRelationNameAttribute.substring(0, separatorIndex);
          var rightId = rightRelationNameAttribute.substr(separatorIndex + 1);
          for (var listIndex = 0; connections[leftId] != null && listIndex < connections[leftId].length; listIndex++) {
            if (connections[leftId][listIndex].id == rightId) {
              connections[leftId][listIndex].attributes.addAll("level" + currentLogicalLevel + "_rightRelation", rightRelationNameAttributes[rightRelationNameAttribute]);
            }
          }
        }
        
      }

      if (currentPhysicalLevel == 0) {
        reportData[currentPath] = connections;
      } else {
        for (var reportDataItem in reportData[currentPath]) {
          var nextConnections = new Array();
          for (var connectionIndex = 0; reportData[currentPath][reportDataItem] != null && connectionIndex < reportData[currentPath][reportDataItem].length; connectionIndex++) {
            var connectionToMatch = reportData[currentPath][reportDataItem][connectionIndex];
            var newConnection = new Array();
            for (var item = 0; connections[connectionToMatch.id] != null && item < connections[connectionToMatch.id].length; item++) {
              var newObject = new Object();
              newObject.id = connections[connectionToMatch.id][item].id;
              if (connections[connectionToMatch.id][item].attributes != null) {
                newObject.attributes = connections[connectionToMatch.id][item].attributes.copy();
              }
              newConnection.push(newObject);
            }
            for (var index = 0; index < newConnection.length; index++) {
              if (newConnection[index].attributes != null) {
                newConnection[index].attributes = newConnection[index].attributes.merge(connectionToMatch.attributes);
              }
            }
            if (newConnection == null && connectionToMatch.id.split(".").length == 4) { //instance id
              newConnection = connections[connectionToMatch.id.substring(0, connectionToMatch.id.lastIndexOf("."))];
            }
            if (newConnection != null) {
              nextConnections = nextConnections.concat(newConnection);
            }
          }
          nextConnections = removeDuplicates(nextConnections);
          reportData[currentPath][reportDataItem] = nextConnections;
        }
      }
    }
  
    if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath].length - 1 == currentPhysicalLevel) { //this is last level
      processPath();
    } else {
      currentPhysicalLevel++;
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].matchinglevel == null) {
        currentLogicalLevel = currentPhysicalLevel;
      } else  {
        currentLogicalLevel = REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].matchinglevel - 1;
      }
    
      var attributes = getQueryAttributes();
      var instance = "";
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].instance != null && REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].instance) {
        instance = ".instances";
      }
      var filter = getFilter();
      var query = "";
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].customQuery != null && REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].customQuery != "") {
        query = REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].customQuery;
        var smStr = getSelectedModels().join(",");
        var patt = new RegExp("SELECTEDMODELS", "g");
        query = query.replace(patt, smStr);
      } else {
        query = "[" + getSelectedModels().join(",") + "].subobjects" + instance;
      }
      oAccessor.oClient.QueryObjects(oAccessor.sSessionId, query, filter, "", attributes.join(","), "", processLevel, handleError);
     }
  }

  function getFilter() {
    var filter = "";
    if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].elementTypes != null && REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].elementTypes[0] != "*") {
      filter = "typename=\"" + REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].elementTypes.join("\" OR typename=\"") + "\"";
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].filter != null && REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].filter != "") {
        filter = "(" + filter + ") AND (" + REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].filter + ")";
      }
    } else {
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].filter != null && REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].filter != "") {
        filter = REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].filter;
      }
    }
    return filter;
  }

  /*
  Get attribute values for chained attributes (using # char)
  */
  function getNextAttributes(result) {
    for (var i = 0; result != null && result.ChildElements != null && i < result.ChildElements.length; i++) {
      var attributeValue = "";
      if (result.ChildElements[i].ChildElements != null && result.ChildElements[i].ChildElements.length > 0) {
        attributesToReplace[getObjectPropertiesInArray(attributesToReplace)[attributeToReplaceIndex]][result.ChildElements[i].Id] = result.ChildElements[i].ChildElements[0].Value;
      }
    }
    
    attributeToReplaceIndex++;
    if (getObjectPropertiesInArray(attributesToReplace).length > attributeToReplaceIndex) {
      var objectIds = new Array();
      var attributeName = getObjectPropertiesInArray(attributesToReplace)[attributeToReplaceIndex];
      if (attributeName.substr(0, 5) == "left_") {
        attributeName = attributeName.substr(5);
        for (var reportDataItem in leftAttributes) {
          if (leftAttributes[reportDataItem][attributeName] != null && leftAttributes[reportDataItem][attributeName] != "") {
            objectIds.push(leftAttributes[reportDataItem][attributeName]);
          }
        }
      } else if (attributeName.substr(0, 6) == "right_") {
        attributeName = attributeName.substr(6);
        for (var reportDataItem in rightAttributes) {
          if (rightAttributes[reportDataItem][attributeName] != null && rightAttributes[reportDataItem][attributeName] != "") {
            objectIds.push(rightAttributes[reportDataItem][attributeName]);
          }
        }
      } else if (attributeName != "_leftRelation" && attributeName != "_rightRelation") {
        for (var reportDataItem in reportData) {
          for (var connectionIndex = 0; reportData[reportDataItem] != null && connectionIndex < reportData[reportDataItem].length; connectionIndex++) {
            if (reportData[reportDataItem][connectionIndex].attributes[attributeName] != null) {
              objectIds.push(reportData[reportDataItem][connectionIndex].attributes[attributeName].join(","));
            }
          }
        }
      }
      objectIds = removeArrayDuplicates(removeArrayEmpties(objectIds.join(",").split(",")));
      if (objectIds.length == 0) {
        getNextAttributes();
      } else {
        attributeName = attributeName.substr(attributeName.indexOf("_") + 1);
        oAccessor.oClient.QueryObjects(oAccessor.sSessionId, "[" + objectIds.join(",") + "]", "", "", attributeName.substr(attributeName.indexOf("#") + 1), "", getNextAttributes, handleError);
      }
    } else {
      getGapAnalysisDataStep1();
    }
  }
  
  /*
  Gets gap analysis related data if gap analysis is in use
  */
  function getGapAnalysisDataStep1() {
    gapAnalysisSeparatorCriteria = REPORT_CONFIGURATION[selectedReportIndex].gapanalysisseparatorcriteria;
    if (gapAnalysisSeparatorCriteria == null || gapAnalysisSeparatorCriteria == "") {
      renderReport();
    } else {
      oAccessor.oClient.QueryObjects(oAccessor.sSessionId, "[" + getObjectPropertiesInArray(reportData).join(",") + "]", gapAnalysisSeparatorCriteria, "", "", "", getGapAnalysisDataStep2, handleError);
    }
  }
  
  function getGapAnalysisDataStep2(result) {
    gapAnalysisLeftObjects = new Object();
    for (var i = 0; result != null && result.ChildElements != null && i < result.ChildElements.length; i++) {
      gapAnalysisLeftObjects[result.ChildElements[i].Id] = true;
    }

    var rightObjects = new Array();
    for (var leftObject in reportData) {
      for (var item = 0; reportData[leftObject] != null && item < reportData[leftObject].length; item++) {
        rightObjects.push(reportData[leftObject][item].id);
      }
    }    
    var gapAnalysisMatchingAttribute = (REPORT_CONFIGURATION[selectedReportIndex].gapanalysismatchingattribute != null && REPORT_CONFIGURATION[selectedReportIndex].gapanalysismatchingattribute != ""?REPORT_CONFIGURATION[selectedReportIndex].gapanalysismatchingattribute:"symbol");
    oAccessor.oClient.QueryObjects(oAccessor.sSessionId, "[" + getObjectPropertiesInArray(reportData).concat(rightObjects).join(",") + "]", "", "", gapAnalysisMatchingAttribute, "", getGapAnalysisDataStep3, handleError);
  }
    
  function getGapAnalysisDataStep3(result) {
    var gapAnalysisMatchingAttributes = new Object();
    for (var i = 0; result != null && result.ChildElements != null && i < result.ChildElements.length; i++) {
      if (result.ChildElements[i].ChildElements != null && result.ChildElements[i].ChildElements.length > 0) {
        gapAnalysisMatchingAttributes[result.ChildElements[i].Id] = result.ChildElements[i].ChildElements[0].Value;
      }
    }
    
    var gapAnalysisLeftIdentifiers = new Object();
    var gapAnalysisRightIdentifiers = new Object();
    for (leftObject in reportData) {
      for (var item = 0; reportData[leftObject] != null && item < reportData[leftObject].length; item++) {
        var leftIdentifier = gapAnalysisMatchingAttributes[leftObject];
        var rightIdentifier = gapAnalysisMatchingAttributes[reportData[leftObject][item].id];
        if (leftObject in gapAnalysisLeftObjects) {
          gapAnalysisLeftIdentifiers[leftIdentifier + "|" + rightIdentifier] = true;
        } else {
          gapAnalysisRightIdentifiers[leftIdentifier + "|" + rightIdentifier] = true;
        }
      }
    }

    for (leftObject in reportData) {
      var leftIdentifier = gapAnalysisMatchingAttributes[leftObject];
      for (var item = 0; reportData[leftObject] != null && item < reportData[leftObject].length; item++) {
        var rightIdentifier = gapAnalysisMatchingAttributes[reportData[leftObject][item].id];
        if (leftObject in gapAnalysisLeftObjects && !((leftIdentifier + "|" + rightIdentifier) in gapAnalysisRightIdentifiers)) { //found only in gap analysis left
          reportData[leftObject][item].gapAnalysisStatus = "Deleted";
          reportData[leftObject][item].gapAnalysisStatusLabel = DELETED_LABEL;
        } else if (!(leftObject in gapAnalysisLeftObjects) && (leftIdentifier + "|" + rightIdentifier) in gapAnalysisLeftIdentifiers) { //gap analysis right to be deleted because same exists also in left
          reportData[leftObject].splice(item, 1);
          item--;
        } else if (!(leftObject in gapAnalysisLeftObjects) && !((leftIdentifier + "|" + rightIdentifier) in gapAnalysisLeftIdentifiers)) { //only exists in right
          reportData[leftObject][item].gapAnalysisStatus = "New";
          reportData[leftObject][item].gapAnalysisStatusLabel = NEW_LABEL;
        }
      }
    }

    renderReport();
  }
      
  /*
  Constructs html table from the calculated report data.
  */
  function renderReport() {
      oAccessor.oClient.LogOff(oAccessor.sSessionId);
    var attributes = REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes;
    var connectionAttributes = getConnectionAttributes();
    var connectionAttributeLabels = getConnectionAttributeLabels();
    var columnWidths = REPORT_CONFIGURATION[selectedReportIndex].columnwidths;
    var lowerHeaderRow = "";
    var columnIndex = 0;
    
    for (var attribute = 0; attribute < attributes.length; attribute++) { lowerHeaderRow = lowerHeaderRow + '<th' + (columnWidths == null || columnWidths.length <= i || columnWidths[i] == ""?"":(' style="width:' + columnWidths[i] + '\"')) + '>' + REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributeLabels[attribute] + '</th>'; columnIndex++;}

    for (var label = 0; label < connectionAttributeLabels.length; label++) { lowerHeaderRow = lowerHeaderRow + '<th' + (columnWidths == null || columnWidths.length <= i || columnWidths[i] == ""?"":(' style="width:' + columnWidths[i] + '\"')) + '>' + connectionAttributeLabels[label] + '</th>'; columnIndex++;}
    
    attributes = REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes;
    if (REPORT_CONFIGURATION[selectedReportIndex].connections[0].length > 1) {
      for (var attribute = 0; attribute < attributes.length; attribute++) { lowerHeaderRow = lowerHeaderRow + '<th' + (columnWidths == null || columnWidths.length <= i || columnWidths[i] == ""?"":(' style="width:' + columnWidths[i] + '\"')) + '>' + REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributeLabels[attribute] + '</th>'; columnIndex++; }
    }
    var columnCount = columnIndex;
    
    separator = new Array();
    var definedSeparator;
    try {
        definedSeparator = $.parseJSON(REPORT_CONFIGURATION[selectedReportIndex].separator);
    } catch(err) {}
    for (var i = 0; i < columnCount; i++) {
      if (definedSeparator != null && definedSeparator.length > i) {
        separator.push(definedSeparator[i]);
      } else if (definedSeparator != null) {
        separator.push("");
      } else {
        separator.push(REPORT_CONFIGURATION[selectedReportIndex].separator==null?"":REPORT_CONFIGURATION[selectedReportIndex].separator);
      }
    }

    $('table#resultTable').children().remove();
    $("div#waitingView").hide();
    
    if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].nodeLabel == null) REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].nodeLabel = "";
    if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].nodeLabel == null) REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].nodeLabel = "";

    var upperHeaderRow = "";
    if ((REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].nodeLabel != null && REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].nodeLabel != "") || (REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].nodeLabel != null && REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].nodeLabel != "")) {
      var leftHeader = ""
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes != null && REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes.length > 0) {
        leftHeader = '<th colspan="' + REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes.length + '">' + REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].nodeLabel + '</th>';
      }
      var rightHeader = "";
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes != null && REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes.length > 0) {
        rightHeader = '<th colspan="' + REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes.length + '">' + REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].nodeLabel + '</th>';
      } 
      var middleHeader = "";
      if (connectionAttributes.length > 0) {
        middleHeader = '<th colspan="' + connectionAttributes.length + '"></th>';
      }
      upperHeaderRow = '<tr>' + leftHeader + middleHeader + rightHeader + '</tr>';
    }
    $('table#resultTable').append('<thead>' + upperHeaderRow + '<tr>' + lowerHeaderRow + '</tr></thead><tbody></tbody>');
    
    var tableData = new Array();

    for (var reportDataItem in reportData) {
      var leftTableRowData = new Array(); //this is collected for grouping
      var leftHtml = "";
      attributes = REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes;
      columnIndex = 0;
      for (var attribute = 0; attribute < attributes.length; attribute++) {
        attributes[attribute] = removeNonValidNameCharacters(attributes[attribute]);
        var addUrlPreFix = "";
        var addUrlPostFix = "";
        if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].portalLinkAttributes != null && REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].portalLinkAttributes.indexOf(attributes[attribute]) > -1) {
          addUrlPreFix = "<a onclick=\"javascript:openPortalUrl('" + reportDataItem + "', 'Details', '');\" style=\"cursor:pointer;\">";
          addUrlPostFix = "</a>";
        }
        if (leftAttributes[reportDataItem] != null && leftAttributes[reportDataItem][attributes[attribute]] != null && attributes[attribute] == "iconurl") {
          leftTableRowData.push(addUrlPreFix + "<img src=\"" + leftAttributes[reportDataItem][attributes[attribute]] + "\"></img>" + addUrlPostFix);
          leftHtml = leftHtml + "<td class=\"iconCell\">" + addUrlPreFix + "<img src=\"" + leftAttributes[reportDataItem][attributes[attribute]] + "\"></img>" + addUrlPostFix + "</td>";
        } else if (leftAttributes[reportDataItem] != null && leftAttributes[reportDataItem][attributes[attribute]] != null) {
          if (attributes[attribute].indexOf("#") > -1) {
            var ids = leftAttributes[reportDataItem][attributes[attribute]].split(",");
            var values = new Array();
            for (var id = 0; id < ids.length; id++) {
              values.push(attributesToReplace["left_" + attributes[attribute]][ids[id]]);
            }
            values = removeArrayEmpties(values);
            leftTableRowData.push(addUrlPreFix + values.sort().join(getSeparator(columnIndex)) + addUrlPostFix);
            leftHtml = leftHtml + "<td sortdata=\"" + encodeURI(mapValues(values).sort().join(getSeparator(columnIndex))) + "\">" + addUrlPreFix + formatValues(mapValues(values).sort(), columnIndex).join(getSeparator(columnIndex)) + addUrlPostFix + "</td>";
          } else {
            leftTableRowData.push(addUrlPreFix + leftAttributes[reportDataItem][attributes[attribute]] + addUrlPostFix);
            leftHtml = leftHtml + "<td sortdata=\"" + encodeURI(mapValue(leftAttributes[reportDataItem][attributes[attribute]])) + "\">" + addUrlPreFix + formatValue(mapValue(leftAttributes[reportDataItem][attributes[attribute]]), columnIndex) + addUrlPostFix + "</td>";
          }
        } else {
          leftTableRowData.push("");
          leftHtml = leftHtml + "<td></td>";
        }
        columnIndex++;
      }
      
      var columnIndexMiddleStart = columnIndex;
      for (var connectionIndex = 0; reportData[reportDataItem] != null && connectionIndex < reportData[reportDataItem].length; connectionIndex++) {
          var tableRowData = [].concat(leftTableRowData); //this is collected for grouping
        columnIndex = columnIndexMiddleStart;
        
          var middleHtml = "";
        for (var attribute = 0; attribute < connectionAttributes.length; attribute++) {
          var attributeValue = reportData[reportDataItem][connectionIndex].attributes[connectionAttributes[attribute]];
          if (attributeValue != null) {
            if (connectionAttributes[attribute].indexOf("#") > -1) {
              var ids = attributeValue.join(",").split(",");
              var values = new Array();
              for (var id = 0; id < ids.length; id++) {
                var value = attributesToReplace[connectionAttributes[attribute]][ids[id]];
                if (value != null) values.push(value);
              }
              values = removeArrayEmpties(values);
              tableRowData.push(removeArrayDuplicates(mapValues(values)).sort().join(getSeparator(columnIndex)));
              middleHtml = middleHtml + "<td sortdata=\"" + encodeURI(removeArrayDuplicates(mapValues(values)).sort().join(getSeparator(columnIndex))) + "\">" + formatValues(removeArrayDuplicates(mapValues(values)).sort(), columnIndex).join(getSeparator(columnIndex)) + "</td>";
            } else {
              tableRowData.push(removeArrayDuplicates(mapValues(attributeValue).sort()).join(getSeparator(columnIndex)));
              middleHtml = middleHtml + "<td sortdata=\"" + encodeURI(removeArrayDuplicates(mapValues(attributeValue).sort()).join(getSeparator(columnIndex))) + "\">" + formatValues(removeArrayDuplicates(mapValues(attributeValue).sort()), columnIndex).join(getSeparator(columnIndex)) + "</td>";
            }
          } else {
            tableRowData.push("");
            middleHtml = middleHtml + "<td></td>";
          }
          columnIndex++;
        }

        var rightHtml = "";
        var gapAnalysisStatus = reportData[reportDataItem][connectionIndex].gapAnalysisStatus == null?"":reportData[reportDataItem][connectionIndex].gapAnalysisStatus;
        var gapAnalysisStatusLabel = reportData[reportDataItem][connectionIndex].gapAnalysisStatusLabel == null?"":reportData[reportDataItem][connectionIndex].gapAnalysisStatusLabel;
        attributes = REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes;
        if (REPORT_CONFIGURATION[selectedReportIndex].connections[0].length == 1) attributes = new Array();
        
          var connectionItem = reportData[reportDataItem][connectionIndex].id;
        for (var attribute = 0; attribute < attributes.length; attribute++) {
          attributes[attribute] = removeNonValidNameCharacters(attributes[attribute]);
          var addUrlPreFix = "";
          var addUrlPostFix = "";
          if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].portalLinkAttributes != null && REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].portalLinkAttributes.indexOf(attributes[attribute]) > -1) {
            addUrlPreFix = "<a onclick=\"javascript:openPortalUrl('" + connectionItem + "', 'Details', '');\" style=\"cursor:pointer;\">";
            addUrlPostFix = "</a>";
          }
          if (rightAttributes[connectionItem] != null && rightAttributes[connectionItem][attributes[attribute]] != null && attributes[attribute] == "iconurl") {
            tableRowData.push(addUrlPreFix + "<img src=\"" + rightAttributes[connectionItem][attributes[attribute]] + "\"></img>" + addUrlPostFix);
            rightHtml = rightHtml + "<td class=\"iconCell\">" + addUrlPreFix + "<img src=\"" + rightAttributes[connectionItem][attributes[attribute]] + "\"></img>" + addUrlPostFix + "</td>";
          } else if (rightAttributes[connectionItem] != null && rightAttributes[connectionItem][attributes[attribute]] != null) {
            if (attributes[attribute].indexOf("#") > -1) {
              var ids = rightAttributes[connectionItem][attributes[attribute]].split(",");
              var values = new Array();
              for (var id = 0; id < ids.length; id++) {
                values.push(attributesToReplace["right_" + attributes[attribute]][ids[id]]);
              }
              values = removeArrayEmpties(values);
              tableRowData.push(addUrlPreFix + values.sort().join(getSeparator(columnIndex)) + addUrlPostFix);
              rightHtml = rightHtml + "<td sortdata=\"" + encodeURI(mapValues(values).sort().join(getSeparator(columnIndex))) + "\">" + addUrlPreFix + formatValues(mapValues(values).sort(), columnIndex).join(getSeparator(columnIndex)) + addUrlPostFix + "</td>";
            } else {
              tableRowData.push(addUrlPreFix + rightAttributes[connectionItem][attributes[attribute]] + addUrlPostFix);
              rightHtml = rightHtml + "<td sortdata=\"" + encodeURI(mapValue(rightAttributes[connectionItem][attributes[attribute]])) + "\">" + addUrlPreFix + formatValue(mapValue(rightAttributes[connectionItem][attributes[attribute]]), columnIndex) + addUrlPostFix + "</td>";
            }
          } else {
            tableRowData.push("");
            rightHtml = rightHtml + "<td></td>";    
          }
          columnIndex++;
        }

        var leftRowCombiningAttribute = "";
        if (reportDataItem in rowCombiningAttributeData) {
          leftRowCombiningAttribute = rowCombiningAttributeData[reportDataItem];
        } else {
          leftRowCombiningAttribute = reportDataItem;
        }
        
        var rightRowCombiningAttribute = "";
        if (connectionItem in rowCombiningAttributeData) {
          rightRowCombiningAttribute = rowCombiningAttributeData[connectionItem];
        } else {
          rightRowCombiningAttribute = connectionItem;
        }
        tableData.push(tableRowData);
        if (REPORT_CONFIGURATION[selectedReportIndex].grouping == null) {
          $('table#resultTable > tbody').append("<tr leftIdentifier=\"" + leftRowCombiningAttribute + "\" rightIdentifier=\"" + rightRowCombiningAttribute + "\" gapAnalysisStatus=\"" + gapAnalysisStatus + "\" gapAnalysisStatusLabel=\"" + gapAnalysisStatusLabel + "\">" + leftHtml + middleHtml + rightHtml + "</tr>");
        }
      }
      
    }

    if (REPORT_CONFIGURATION[selectedReportIndex].grouping != null) {  //if grouping is in use
      tableData = processGrouping(tableData);
      for (var i = 0; i < tableData.length; i++) {
        var tableRowHtml = "";
        for (var j = 0; j < tableData[i].length; j++) {
          tableRowHtml = tableRowHtml + "<td>" + formatValue(mapValue(tableData[i][j]), j) + "</td>";
        }
        $('table#resultTable > tbody').append("<tr>" + tableRowHtml + "</tr>");
      }
    }
    
    var hideBorders = sGetParameter("hideborders", sGetDocumentLocation());
    hideBorders = (hideBorders == "true");
    var columnFormats = new Array();
    var columnTypeDefinitions = REPORT_CONFIGURATION[selectedReportIndex].columnformats;
    for (var i = 0; i < columnCount; i++) {
      if (columnTypeDefinitions != null && columnTypeDefinitions.length > i && columnTypeDefinitions[i] != null && (["string", "numeric", "date", "datetime"].indexOf(columnTypeDefinitions[i].toLowerCase()) > -1 || columnTypeDefinitions[i].toLowerCase().substr(0, 8) == "numeric:")) {
        var item = new Object();
        item.sType = columnTypeDefinitions[i].toLowerCase();
        if (item.sType.substr(0, 8) == "numeric:") item.sType = "numeric";
        columnFormats.push(item);
      } else {
        columnFormats.push(null);
      }
    }

    oTable = $('#resultTable').dataTable({
      "aaSorting": (REPORT_CONFIGURATION[selectedReportIndex].sorting != null && REPORT_CONFIGURATION[selectedReportIndex].sorting != ""?REPORT_CONFIGURATION[selectedReportIndex].sorting:[[0,'asc']]),
      "aoColumns": columnFormats,
      "iDisplayLength": -1,
      "bPaginate": !hideBorders,
      "bFilter": !hideBorders,
      "bInfo": !hideBorders,
      'aLengthMenu': [[20, 50, 200, 1000, -1], [20, 50, 200, 1000, 'All']],
      "fnDrawCallback": drawTableCombinings
    });

    $.fn.dataTableExt.oSort['datetime-asc']  = sortDatesAscending;
    $.fn.dataTableExt.oSort['datetime-desc'] = sortDatesDescending;

    $('div#reportLabel').html(REPORT_CONFIGURATION[selectedReportIndex].name);
    $('div#resultsLabel').css("display", (hideBorders?"none":"block"));
    $('body').css("margin-bottom", (hideBorders?"0px":"20px"));
    $(".dataTables_wrapper").css({"margin-left":(hideBorders?"0px":"10px"),"margin-right":(hideBorders?"0px":"10px"),"margin-top":(hideBorders?"0px":"10px"),"margin-bottom":(hideBorders?"0px":"10px")});
    $('div#resultsView').show();
    
    oTableFixedHeader = new FixedHeader(oTable);
  }
  
  /*
  Groups table data
  */
  function processGrouping(inputTable) {      
    if (inputTable.length == 0) return inputTable;
    var groupingConfiguration = REPORT_CONFIGURATION[selectedReportIndex].grouping;
    inputTable.sort(function(a, b) {
      for (var i = 0; i < a.length; i++) {
        if (groupingConfiguration.length < i || groupingConfiguration[i] == null) {
          if (a[i] < b[i])
            return -1;
          else if (a[i] > b[i])
            return 1; 
        }
      }
      return 0;
    });
    
    var outputTable = new Array();
    var groupingValues = new Object();
    for (var j = 0; j < inputTable[0].length; j++) {
      if (groupingConfiguration.length >= j && groupingConfiguration[j] != null) {
        groupingValues[j] = new Array();
        groupingValues[j].push(inputTable[0][j]);
      }
    }

    for (var i = 1; i < inputTable.length; i++) {
      var newGroupRow = false;
      var index = 0;
      while (!newGroupRow && inputTable[i].length > index) {
        if ((groupingConfiguration.length < index || groupingConfiguration[index] == null) && inputTable[i][index] != inputTable[i - 1][index]) newGroupRow = true;
        index++;
      }
      if (newGroupRow) {
        var row = new Array();
        for (var j = 0; j < inputTable[i].length; j++) {
          if (groupingConfiguration.length < j || groupingConfiguration[j] == null) {
            row.push(inputTable[i - 1][j]);
          } else {
            row.push(groupListOfData(groupingValues[j], groupingConfiguration[j].toLowerCase(), j));
          }
          if (groupingConfiguration.length >= j && groupingConfiguration[j] != null) {
            groupingValues[j] = new Array();
            groupingValues[j].push(inputTable[i][j]);
          }
        }
        outputTable.push(row);
      } else {
        for (var j = 0; j < inputTable[i].length; j++) {
          if (groupingConfiguration.length >= j && groupingConfiguration[j] != null) {
            groupingValues[j].push(inputTable[i][j]);
          }
        }
      }
    }
    return outputTable;
  }
  
  function groupListOfData(inputArray, groupingFunction, columnIndex) {
    if (inputArray == null || inputArray.length == 0) return "";
    var result;
    if (groupingFunction == "count") {
      result = inputArray.length;
    } else if (groupingFunction == "sum") {
      result = 0;
      for (var i = 0; i < inputArray.length; i++) {
        var itemAsNumeric = parseFloat(inputArray[i]);
        if (isNaN(itemAsNumeric)) itemAsNumeric = 0;
        result = result + itemAsNumeric;
      }
    } else if (groupingFunction == "average" || groupingFunction == "average_") {
      var itemCount = 0;
      result = 0;
      for (var i = 0; i < inputArray.length; i++) {
        var itemAsNumeric = parseFloat(inputArray[i]);
        if (!isNaN(itemAsNumeric) && (groupingFunction != "average_" || (itemAsNumeric != null && itemAsNumeric != ""))) itemCount++;
        if (isNaN(itemAsNumeric)) itemAsNumeric = 0;
        result = result + itemAsNumeric;
      }
      if (itemCount == 0) result = "";
      else result = result / itemCount;
    } else if (groupingFunction == "concatenate") {
      result = inputArray.join(getSeparator(columnIndex));
    } else {
      result = "[unknown grouping function \"" + groupingFunction + "\"]";
    }
    return result;
  }
  
  function getSeparator(columnIndex) {
    return separator[columnIndex];
  }
  
  function sortDatesAscending(x, y) {
    var dateX;
    if (x == null || x == "") {
      dateX = 0;
    } else {
      dateX = $.datepicker.parseDate(OUTPUT_DATE_FORMAT, x);
    }
    if (y == null || y == "") {
      dateY = 0;
    } else {
      dateY = $.datepicker.parseDate(OUTPUT_DATE_FORMAT, y);
    }
    return ((dateX < dateY) ? -1 : ((dateX > dateY) ?  1 : 0));
  }
  
  function sortDatesDescending(x, y) {
    return -sortDatesAscending(x, y);
  }
  
  function removeArrayEmpties(input) {
    var output = new Array();
    for (var item = 0; input != null && item < input.length; item++) {
      if (input[item] != null && input[item] != "") {
        output.push(input[item]);
      }
    }
    return output;
  }
  
  function drawTableCombinings(oSettings) {
    if (REPORT_CONFIGURATION[selectedReportIndex].grouping != null) return;
    $(this).children().eq(1).children().children().css("visibility", "visible");
    $(this).children().eq(1).children().children().css("border-bottom-style", "inherit"); 
    $(this).children().eq(1).children().children().removeClass("gapAnalysisHighlightNew gapAnalysisHighlightDeleted");
    $(this).children().eq(1).children().children().filter(".gapanalysisstatus").remove();
      
    $(this).children().eq(1).children().each(function() {
      var leftAttributesLength = 0;
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes != null) {
        var leftAttributesLength = REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes.length;
      }
      var rightAttributesLength = 0;
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes != null) {
        var rightAttributesLength = REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes.length;
      }

      var gapAnalysisStatus = $(this).attr("gapAnalysisStatus");
      var gapAnalysisStatusLabel = $(this).attr("gapAnalysisStatusLabel");
      var startColumn = leftAttributesLength + getConnectionAttributes().length;

      if (oSettings.aaSorting[0][0] < leftAttributesLength) {
        var currentIdentifier = $(this).attr("leftIdentifier");
        var previousIdentifier = $(this).prev().attr("leftIdentifier");
        if (currentIdentifier == previousIdentifier) {
          for (var i = 0; i < leftAttributesLength; i++) {
            $(this).children().eq(i).css("visibility", "hidden");
            $(this).prev().children().eq(i).css("border-bottom-style", "hidden"); 
            }
        }
        if (gapAnalysisStatus != null && gapAnalysisStatus != "") {
          for (var i = startColumn; i < (startColumn + rightAttributesLength); i++) {
            if (REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatushighlightcolumns == null || REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatushighlightcolumns.indexOf(i + 1) > -1) {
              $(this).children().eq(i).addClass("gapAnalysisHighlight" + gapAnalysisStatus);
            }
            if (REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatuscolumns != null && REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatuscolumns.indexOf(i + 1) > -1) {
              $(this).children().eq(i).html(gapAnalysisStatusLabel);
              $(this).children().eq(i).addClass("gapAnalysis" + gapAnalysisStatus);
            }
          }
          for (var i = 0; i < leftAttributesLength; i++) {
            if (REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatuscolumns != null && REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatuscolumns.indexOf(i + 1) > -1) {
              $(this).children().eq(i).html("");
            }
          }
        }
      }
        
      if (oSettings.aaSorting[0][0] >= leftAttributesLength) {
        currentIdentifier = $(this).attr("rightIdentifier");
        previousIdentifier = $(this).prev().attr("rightIdentifier");
        if (currentIdentifier == previousIdentifier) {
          for (var i = startColumn; i < (startColumn + rightAttributesLength); i++) {
            $(this).children().eq(i).css("visibility", "hidden");
            $(this).prev().children().eq(i).css("border-bottom-style", "hidden"); 
          }
        }
        if (gapAnalysisStatus != null && gapAnalysisStatus != "") {
          for (var i = 0; i < leftAttributesLength; i++) {
            if (REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatushighlightcolumns == null || REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatushighlightcolumns.indexOf(i + 1) > -1) {
              $(this).children().eq(i).addClass("gapAnalysisHighlight" + gapAnalysisStatus);
            }
            if (REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatuscolumns != null && REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatuscolumns.indexOf(i + 1) > -1) {
              $(this).children().eq(i).html(gapAnalysisStatusLabel);
              $(this).children().eq(i).addClass("gapAnalysis" + gapAnalysisStatus);
            }
          }
          for (var i = startColumn; i < (startColumn + rightAttributesLength); i++) {
            if (REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatuscolumns != null && REPORT_CONFIGURATION[selectedReportIndex].gapanalysisstatuscolumns.indexOf(i + 1) > -1) {
              $(this).children().eq(i).html("");
            }
          }
        }
      }
    });
    if (oTableFixedHeader) oTableFixedHeader.fnUpdate();
  }
      
  /*
  Constructs a list of attributes for a single node that are used in web service query.
  */
  function getQueryAttributes() {
    var attributes = new Array();
    var connectionArray = REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToPrevious;
    for (var i = 0; connectionArray != null && i < connectionArray.length; i++) {
      var connection = connectionArray[i];
      attributes.push("related(relation=\"" + connection + "\", as=\"left_" + connection + "\")");
    }
    
    connectionArray = REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath][currentPhysicalLevel].connectionToNext;
    for (var i = 0; connectionArray != null && i < connectionArray.length; i++) {
      var connection = connectionArray[i];
      attributes.push("related(relation=\"" + connection + "\", as=\"right_" + connection + "\")");
    }
    
    var referencedLogicalLevel = currentLogicalLevel; //in case local level is defined too big by accident
    if (REPORT_CONFIGURATION[selectedReportIndex].connections[0].length <= referencedLogicalLevel) {
      referencedLogicalLevel = REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1;
    }
    
    var attributeArray = REPORT_CONFIGURATION[selectedReportIndex].connections[0][referencedLogicalLevel].attributes;
    for (var i = 0; attributeArray != null && i < attributeArray.length; i++) {
      var attribute = attributeArray[i];
      var wsattribute = attributeArray[i];
      if (attribute.indexOf("#") > -1) {
        wsattribute = attribute.substr(0, attribute.indexOf("#"));
        attribute = attribute.replace("#", "_hash_");
      }
      var queryAttribute = "";
      if (wsattribute.indexOf("(") > -1) {
        queryAttribute = wsattribute.substr(0, wsattribute.length - 1) + ", as=\"attribute_" + removeNonValidNameCharacters(attribute) + "\")";
      } else {
        queryAttribute = wsattribute + "(as=\"attribute_" + removeNonValidNameCharacters(attribute) + "\")";
      }
      attributes.push(queryAttribute);
    }

    if (currentPhysicalLevel == 0 || REPORT_CONFIGURATION[selectedReportIndex].connections[currentPath].length - 1 == currentPhysicalLevel) {
      var rowCombiningAttribute = REPORT_CONFIGURATION[selectedReportIndex].rowcombiningattribute!=null?REPORT_CONFIGURATION[selectedReportIndex].rowcombiningattribute:"symbol";
      attributes.push(rowCombiningAttribute + "(as=\"rowcombiningattribute\")");
    }
    return attributes;
  }
  
  function removeNonValidNameCharacters(input) {
    return input.replace("(", "").replace(")", "").replace("\"", "").replace("\"", "").replace("=", "");
  }
  
  function getConnectionAttributes() {
    var attributes = new Array();
    for (var index = 0; REPORT_CONFIGURATION[selectedReportIndex].connections[0] != null && index < REPORT_CONFIGURATION[selectedReportIndex].connections[0].length; index++) {
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].connectionToPreviousAsAttribute) {
        attributes.push("level" + index + "_leftRelation");
      }
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].connectionToNextAsAttribute) {
        attributes.push("level" + index + "_rightRelation");
      }
      if (index != 0 && index != REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1) {
        for (var index2 = 0; REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].attributes != null && index2 < REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].attributes.length; index2++) {
          if (typeof REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].attributes[index2] === 'string') {
            attributes.push("level" + index + "_" + removeNonValidNameCharacters(REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].attributes[index2]));
          }
        }
      }
    }
    return attributes;
  }
  
  function getAllAttributes() {
      var allAttributes = new Array();
    for (var item = 0; REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes != null && item < REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes.length; item++) {
      if (typeof REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes[item] === 'string') {
        allAttributes.push("left_" + REPORT_CONFIGURATION[selectedReportIndex].connections[0][0].attributes[item]);
      }
    }
    allAttributes = allAttributes.concat(getConnectionAttributes());
    for (var item = 0; REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes != null && item < REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes.length; item++) {
      if (typeof REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes[item] === 'string') {
        allAttributes.push("right_" + REPORT_CONFIGURATION[selectedReportIndex].connections[0][REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1].attributes[item]);
      }
    }
    return allAttributes;
  }
  
  function getConnectionAttributeLabels() {
    var attributeLabels = new Array();
    for (var index = 0; REPORT_CONFIGURATION[selectedReportIndex].connections[0] != null && index < REPORT_CONFIGURATION[selectedReportIndex].connections[0].length; index++) {
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].connectionToPreviousAsAttribute) {
        if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].connectionToPreviousAttributeLabel != null) {
          attributeLabels.push(REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].connectionToPreviousAttributeLabel);
        } else {
          attributeLabels.push("Relation name");
        }
      }
      if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].connectionToNextAsAttribute) {
        if (REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].connectionToNextAttributeLabel != null) {
          attributeLabels.push(REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].connectionToNextAttributeLabel);
        } else {
          attributeLabels.push("Relation name");
        }
      }
      if (index != 0 && index != REPORT_CONFIGURATION[selectedReportIndex].connections[0].length - 1) {
        for (var index2 = 0; REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].attributeLabels != null && index2 < REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].attributeLabels.length; index2++) {
          attributeLabels.push(REPORT_CONFIGURATION[selectedReportIndex].connections[0][index].attributeLabels[index2]);
        }
      }
    }
    return attributeLabels;
  }  
  
  function mapValues(inputArray) {
    if (REPORT_CONFIGURATION[selectedReportIndex].mappings == null) return inputArray;
    var outputArray = new Array();
    for (var item = 0; item < inputArray.length; item++) {
      outputArray.push(mapValue(inputArray[item]));
    }
    return outputArray;
  }

  function mapValue(value) {
    if (REPORT_CONFIGURATION[selectedReportIndex].mappings == null) return value;
    var newValue = REPORT_CONFIGURATION[selectedReportIndex].mappings[value];
    if (newValue == null) newValue = value;
    return newValue;
  }
  
  function formatValues(inputArray, columnIndex) {
    var outputArray = new Array();
    for (var item = 0; item < inputArray.length; item++) {
      outputArray.push(formatValue(inputArray[item], columnIndex));
    }
    return outputArray;
  }
  
  function formatValue(value, columnIndex) {
    if (value == null || value == "") return "";
    if (REPORT_CONFIGURATION[selectedReportIndex].columnformats != null && REPORT_CONFIGURATION[selectedReportIndex].columnformats.length > columnIndex && REPORT_CONFIGURATION[selectedReportIndex].columnformats[columnIndex] == "datetime") {
      value = value.substr(0, 10);
      return $.datepicker.formatDate(OUTPUT_DATE_FORMAT, $.datepicker.parseDate(XML_DATE_FORMAT, value));
    } else if (REPORT_CONFIGURATION[selectedReportIndex].columnformats != null && REPORT_CONFIGURATION[selectedReportIndex].columnformats.length > columnIndex && REPORT_CONFIGURATION[selectedReportIndex].columnformats[columnIndex] != null && REPORT_CONFIGURATION[selectedReportIndex].columnformats[columnIndex].substr(0, 8) == "numeric:") {
      var numberFormat = REPORT_CONFIGURATION[selectedReportIndex].columnformats[columnIndex].substr(8);
      return $.formatNumber(value, { format: numberFormat, locale: NUMBER_FORMAT_LOCALE });
    } else {
      return value;
    }
  }
  
  function openPortalUrl(objectId, viewName, options) {
    openPortalUrlObjectId = objectId;
    openPortalUrlViewName = viewName;
    openPortalUrlOptions = options;
    oAccessor.AutoAuthenticate(openPortalUrl_step1, handleError);
  }
    
  function openPortalUrl_step1() {
    oAccessor.oClient.GetPortalUrl(oAccessor.sSessionId, openPortalUrlObjectId, openPortalUrlViewName, openPortalUrlOptions, openPortalUrl_step2, handleError);
  }

  function openPortalUrl_step2(result) {
    oAccessor.oClient.LogOff(oAccessor.sSessionId);
    window.open(result, "_blank", "", false);
  }
      
  function removeDuplicates(connectionArray) {
    if (connectionArray == null || connectionArray.length < 2) return connectionArray;
    connectionArray.sort(function(a, b) {if (typeof a == "undefined" || typeof a == "undefined") return null; else if (a.id < b.id) return -1; else if (a.id > b.id) return 1; else return 0;});
    var index = 0;
    while (index < connectionArray.length - 1) {
      if (connectionArray[index].id == connectionArray[index + 1].id) {
        if (connectionArray[index].attributes != null) {
          connectionArray[index].attributes = connectionArray[index].attributes.merge(connectionArray[index + 1].attributes);
        }
        connectionArray.splice(index + 1, 1);
      } else {
        index++;
      }
    }
    return connectionArray;
  }
  
  function AttributeCollection() {}
 
  AttributeCollection.prototype.merge = function(anotherCollection) {
    var returnedConnection = this.copy();    
    for (var attribute in anotherCollection) {
      if (typeof returnedConnection[attribute] != "function") {
        if (returnedConnection[attribute] == null) {
          returnedConnection[attribute] = anotherCollection[attribute].slice(0);
        } else {
          returnedConnection[attribute] = returnedConnection[attribute].concat(anotherCollection[attribute]);
          returnedConnection[attribute] = removeArrayDuplicates(returnedConnection[attribute]);
        }
      }
    }
    return returnedConnection;
  }

  AttributeCollection.prototype.add = function(attribute, attributeValue) {
    if (this[attribute] == null) {
      this[attribute] = new Array();
    }
    this[attribute].push(attributeValue);
  }
  
  AttributeCollection.prototype.addAll = function(attribute, attributeArray) {
    if (this[attribute] == null) {
      this[attribute] = new Array();
    }
    this[attribute] = this[attribute].concat(attributeArray);
  }
  
  AttributeCollection.prototype.copy = function() {
    var returnedConnection = new AttributeCollection();
    for (var attribute in this) {
      if (typeof returnedConnection[attribute] != "function") {
        returnedConnection[attribute] = this[attribute].slice(0);
      }
    }
    return returnedConnection;
  }

  function initializeWindow() {
    windowResized();
    $("div#reportGenerationText").hide()
    $('#reportNameParametersView').click(function() {$("#urlLabel").hide();});
    $("#urlLabel").focus(function() {$(this).select();});
    $('#reportLabel').click(function() {
      $("#reportLabel").hide();
      $("#reportNameResultsView").show();
      $("#reportNameResultsView").focus();
    });
    $('#reportNameResultsView').change(function(event) {
      $("div#resultsView").hide();
      $("div#waitingView").show();
      selectedReportIndex = $("select#reportNameResultsView").val();
      $('select#reportNameParametersView').val(selectedReportIndex);
      oTable.fnDestroy();
      $('div.fixedHeader').remove();
      openReport();
    });
    $('#reportNameResultsView').blur(function() {
      $("#reportLabel").show();
      $("#reportNameResultsView").hide();
    });
    oAccessor = WSFUtils();
    oAccessor.LoadProxy(step1, handleError);
  }
    
  function step1() {
    oAccessor.AutoAuthenticate(step2, handleError);
  }
    
  function step2() {
    var configurationAttributes = new Array();
    for (var attribute = 0; attribute < CONFIGURATION_ATTRIBUTES.length; attribute++) {
      configurationAttributes.push(CONFIGURATION_ATTRIBUTES[attribute] + ".value(as=\"" + CONFIGURATION_ATTRIBUTES[attribute] + "\")");
    }
    var configurationModel = REPORT_CONFIGURATION_MODEL;
    if (!USE_GLOBAL_CONFIGURATION_MODEL) {
      configurationModel = sDecodeURI(sGetParameter("configurationmodel", sGetDocumentLocation()));
    }
    oAccessor.oClient.QueryObjects(oAccessor.sSessionId, "[" + configurationModel + "].subobjects", "typename=\"" + REPORT_CONFIGURATION_ELEMENTTYPE + "\"", "name", configurationAttributes.join(","), "", step3, handleError);
  }
  
  function step3(result) {
    REPORT_CONFIGURATION = new Array();
    for (var i = 0; result.ChildElements != null && i < result.ChildElements.length; i++) {
      var report = new Object();
      for (var j = 0; result.ChildElements[i].ChildElements != null && j < result.ChildElements[i].ChildElements.length; j++) {
        try {
          if (result.ChildElements[i].ChildElements[j].Value == null) result.ChildElements[i].ChildElements[j].Value = "";
          if (JSON_ATTRIBUTES.indexOf(result.ChildElements[i].ChildElements[j].Name) > -1) {
            report[result.ChildElements[i].ChildElements[j].Name.toLowerCase()] = $.parseJSON(result.ChildElements[i].ChildElements[j].Value);
          } else {
            report[result.ChildElements[i].ChildElements[j].Name.toLowerCase()] = result.ChildElements[i].ChildElements[j].Value;
          }
        } catch(err) {
          alert("Error in report \"" + report.name + "\". " + err);
          parent.window.close();
        }
      }
      REPORT_CONFIGURATION.push(report);
    }
    
    var report = sDecodeURI(sGetParameter("report", sGetDocumentLocation()));
    for (var i = 0; i < REPORT_CONFIGURATION.length; i++) {
      $('select#reportNameParametersView, select#reportNameResultsView').append('<option value="' + i + '" title="' + REPORT_CONFIGURATION[i].description + '">' + REPORT_CONFIGURATION[i].name + '</option>');
      if (REPORT_CONFIGURATION[i].name == report) {
        selectedReportIndex = i;
      }
    }
    $('select#reportNameParametersView, select#reportNameResultsView').val(selectedReportIndex);
    oAccessor.oClient.QueryObjects(oAccessor.sSessionId, "[PG].subobjects", "typename=\"RootModel\"", "", "folder.id(as=\"folder\")", "", step4, handleError);
  }
  
  function step4(result) {
    for (var i = 0; result.ChildElements != null && i < result.ChildElements.length; i++) {
      var elementId = result.ChildElements[i].Id;
      var parentObject = getAttributeValue(result.ChildElements[i].ChildElements, "folder");
      rootModelParents[elementId] = parentObject;
    }
    oAccessor.oClient.QueryObjects(oAccessor.sSessionId, "[PG].folders", "", "", "name,folder.id(as=\"folder\")", "", step5, handleError);
  }
  
  function step5(result) {
    $("div#tree").dynatree({
       selectMode: 3,
       checkbox: true,
       clickFolderMode: 3,
       imagePath: "<#ImageFileLocation>../../pg/images/",
       minExpandLevel: 2,
       onClick: function() {
         $("#urlLabel").hide();
       }
    });
    
    var addedElementsCount = 0;
    var tree = $("div#tree").dynatree("getTree");
    serverNode = tree.getRoot().addChild({title: "QPR BizArchitecture Server", key: "server", noLink: true, isFolder: true, elementName: elementName});

    do {
      addedElementsCount = 0;
      for (var i = 0; result.ChildElements != null && i < result.ChildElements.length; i++) {
        var elementId = result.ChildElements[i].Id;
        if (tree.getNodeByKey(elementId) == null) {
          var elementName = getAttributeValue(result.ChildElements[i].ChildElements, "name");
          var parentObject = getAttributeValue(result.ChildElements[i].ChildElements, "folder");
          if (parentObject == "") {
            serverNode.addChild({title: elementName, key: elementId, noLink: true, isFolder: true, elementName: elementName,});
            addedElementsCount++;
          } else if (tree.getNodeByKey(parentObject) != null) {
            tree.getNodeByKey(parentObject).addChild({title: elementName, key: elementId, noLink: true, isFolder: true, elementName: elementName});
            addedElementsCount++;
          }
        }
      }
    } while (addedElementsCount > 0);
    
    oAccessor.oClient.QueryObjects(oAccessor.sSessionId, "[PG].models", "typename<>\"BaseModel\"", "", "name,typename,creationdate,version,folder.id(as=\"folder\")", "", step6, handleError);
  }
  
  function step6(result) {
    oAccessor.oClient.LogOff(oAccessor.sSessionId);
    var activeModel = sGetParameter("activemodel", sGetDocumentLocation());
    
    var addedElementsCount = 0;
    var tree = $("div#tree").dynatree("getTree");

    do {
      addedElementsCount = 0;
      for (var i = 0; result.ChildElements != null && i < result.ChildElements.length; i++) {
        var elementId = result.ChildElements[i].Id.replace(".-1", "").replace(".-2", "").replace(".-3", "").replace(".-4", "");
        if (tree.getNodeByKey(elementId) != null) continue;
        var selected;
        var models = sDecodeURI(sGetParameter("models", sGetDocumentLocation()));
        if (models == "") {
          selected = (elementId == activeModel);
        } else {
          selected = (models.split(",").indexOf(elementId) > -1);
        }
        if (tree.getNodeByKey(elementId) == null && result.ChildElements[i].ChildElements.length > 1) {
          var elementName = getAttributeValue(result.ChildElements[i].ChildElements, "name");
          var elementType = getAttributeValue(result.ChildElements[i].ChildElements, "typename");
          var creationDate = getAttributeValue(result.ChildElements[i].ChildElements, "creationdate");
          var version = getAttributeValue(result.ChildElements[i].ChildElements, "version");
          var parentObject = getAttributeValue(result.ChildElements[i].ChildElements, "folder");
          
          if (version != "") {
            version = " (" + version + ")";
          }
          var elementIcon = "";
          if (elementType == "BaseModel") {
            elementIcon = "icn_basemodel.gif";
          } else if (elementType == "ChildModel") {
            elementIcon = "icn_childmodel.gif";
          } else {
            elementIcon = "icn_model.gif";
          }
          if (parentObject == "" || (tree.getNodeByKey(parentObject) == null && tree.getNodeByKey(rootModelParents[parentObject]) == null)) {
            serverNode.addChild({title: elementName + version, key: elementId, noLink: true, icon: elementIcon, select: selected, elementName: elementName, creationDate: creationDate, version: version});
            if (selected) serverNode.expand(true);
            addedElementsCount++;
          } else if (tree.getNodeByKey(parentObject) == null) {
            tree.getNodeByKey(rootModelParents[parentObject]).addChild({title: elementName + version, key: elementId, noLink: true, icon: elementIcon, select: selected, elementName: elementName, creationDate: creationDate, version: version});
            if (selected) tree.getNodeByKey(rootModelParents[parentObject]).expand(true);
            addedElementsCount++;
          } else if (tree.getNodeByKey(parentObject) != null) {
            tree.getNodeByKey(parentObject).addChild({title: elementName + version, key: elementId, noLink: true, icon: elementIcon, select: selected, elementName: elementName, creationDate: creationDate, version: version});
            if (selected) tree.getNodeByKey(parentObject).expand(true);
            addedElementsCount++;
          }
        }
      }
    } while (addedElementsCount > 0);
    
    serverNode.sortChildren(sortTreeItems, true);

    if (sGetParameter("run", sGetDocumentLocation()) == "true") {
      runReport();
    } else {
      $("div#waitingView").hide();
      $("div#parametersView").show();
    }
  }

  function getAttributeValue(data, attributeName) {
    if (data == null) return "";
    for (var i = 0; i < data.length; i++) {
      if (data[i].Name == attributeName) return data[i].Value;
    }
    return "";
  }
  
  function prepareForExcel() {
    $("div#parametersView").remove();
    $('div#resultsLabel').remove();
    $("div#waitingView").remove();
    oTable.fnDestroy();
    $('div.fixedHeader').remove();
    $('table#resultTable').removeClass("display");
  }

  function backToParametersView() {
    oTable.fnDestroy();
    $("div#parametersView").show();
    $("div#resultsView").hide();
    $('div.fixedHeader').remove();
  }
  
  function toggleLink() {
    $("#urlLabel").width($("#parametersView").width() - 42);
      if ($('select#reportNameParametersView').val() == null) {
      alert("No report is selected.");
      return;
    }
    if ($("#urlLabel").css("display") != "none") {
      $("#urlLabel").hide();
    } else {
      refreshLink();
      $("#urlLabel").show();
    }
  }
  
  function getReportLink() {
    var link = sGetDocumentLocation();
    link = link.substring(0, link.indexOf("QPRPORTAL&*putab&") + 16);
    link = sSetParameter("TPL", "impactanalysis.tpl", link);
    link = sSetParameter("report", sEncodeURI($("#reportNameParametersView").find("option[value='" + $("#reportNameParametersView").val() + "']").text()), link);
    link = sSetParameter("models", getSelectedModels(), link);
    link = sSetParameter("run", "true", link);
    link = sSetParameter("hideborders", "false", link);
    if (!USE_GLOBAL_CONFIGURATION_MODEL) {
      link = sSetParameter("configurationmodel", sDecodeURI(sGetParameter("configurationmodel", sGetDocumentLocation())), link);
    }
    link = sRemoveParameter("FOO", link);
    return link;
  }
  
  function refreshLink() {
    $("#urlLabel").val(getReportLink());
  }
  
  function windowResized() {
    var table = $("div#waitingView > table");
    table.css("margin-left", (($(window).width() - table.width()) / 2) + "px");
    table.css("margin-top", (($(window).height() - table.height()) / 2) + "px");
    $("#urlLabel").width($("#parametersView").width() - 42);
  }
  
  function openReport() {
    if ($('select#reportNameParametersView').val() == null) {
      alert("No report is selected.");
      return;
    }
    $("div#reportGenerationText").show();
    window.location.href = getReportLink();
  }
  
  function sortTreeItems(a, b) {
    var a_folder = a.data.isFolder;
    var b_folder = b.data.isFolder;
    var a_name = a.data.elementName.toLowerCase();
    var b_name = b.data.elementName.toLowerCase();
    var a_version = a.data.version;
    var b_version = b.data.version;
    if (a_folder != b_folder) {
     return a_folder;
    }
    return a_name > b_name ? 1 : (a_name < b_name ? -1 : (a_version > b_version ? -1 : (a_version < b_version ? 1 : 0)));
  }
  
  function removeArrayDuplicates(inputArray) {
    b = {};
    for (var i = 0; i < inputArray.length; i++) {
      b[inputArray[i]] = inputArray[i];
    }
    c = [];
    for (var key in b) {
      c.push(key);
    }
    return c;
  }
  
  function getObjectPropertiesInArray(inputObject) {
    var outputArray = new Array();
    $.each(inputObject, function(name, value) {
      outputArray.push(name);
    });
    return outputArray;
  }
  
  function handleError(result) {
    var errorMessage = "";
    if (result != null && typeof(result.get_message) != "undefined") { 
      errorMessage = result.get_message();
    }
    alert("Error occured. Please try run the report again. \n\Error message:\n" + errorMessage);
    parent.window.close();
  }
 
</script>

</head>

<body style="margin-bottom:20px;" onload="initializeWindow();" onresize="windowResized();">

<div id="parametersView" style="display:none;">
  <div id="PopupHeader">
    <img src="<#PortalImageFileLocation>header_icon_manage.png" />
    <h1>Impact Analysis</h1>
  </div>
  <div id="reportNameDiv" style="margin-top:15px;margin-left:20px;"><#LocalizedText id="Report">: <select id="reportNameParametersView" style="min-width:200px;"></select></div>
  <div style="margin-top:15px;margin-left:20px;margin-right:20px;" id="tree"></div>
  <div style="margin-top:15px;margin-left:20px;margin-bottom:15px;">
    <input class="ButtonLeft" type="button" value="<#LocalizedText id="Run report">" onclick="openReport();" />
    <input class="ButtonLeft" type="button" value="<#LocalizedText id="Get link">" onclick="toggleLink();" />
    <input class="ButtonLeft" type="button" value="<#LocalizedText id="Close">" onclick="parent.window.close();" />
  </div>
  <input style="display:none;margin-top:15px;margin-left:20px;" type="text" id="urlLabel" readonly="readonly" />
</div>

<div id="resultsView" style="display:none;">
  <div id="resultsLabel" style="margin-top:15px;margin-left:15px;margin-bottom:15px;height:25px;">
      <div id="backButton" style="display:inline;margin-right:10px;">
      <a onclick="backToParametersView();" href="#">
        <img style="margin-top:8px;" src="<#PortalImageFileLocation>icon_back.png" title="<#LocalizedText id="Back to report selection">" />
      </a>
    </div>
    <div id="reportLabel" style="font-size:170%;display:inline;cursor:pointer;"></div>
    <select id="reportNameResultsView" style="min-width:200px;display:none;vertical-align:middle;margin-bottom:9px;"></select>
    <div id="excelExport" style="display:inline;margin-right:12px;float:right;">
      <a onclick="prepareForExcel();" href="#">
        <img src="<#PortalImageFileLocation>icon_excel.gif" title="<#LocalizedText id="Prepare for Excel">" />
      </a>
    </div>
  </div>
  <table cellpadding="0" cellspacing="0" border="0" class="display" width="100%" id="resultTable"></table>
</div>

<div id="waitingView" style="width: 100%; height: 100%; position: relative; margin-top: 200px;">
  <div id="genericWaitText" style="position: absolute; left: 0; right: 0; top: 0; bottom: 0; float: left;">
    <img style="display: table; margin: auto;" src="<#PortalImageFileLocation>icon_waiting.gif" />
      <p style="display: table; margin-right: auto; margin-left: auto;"><#LocalizedText id="Loading, please wait">...</p>
  </div>
  <div id="reportGenerationText" style="padding-top:70px; margin-left: auto; margin-right: auto; display: table;">
      <p><#LocalizedText id="Please wait - Generating the report may take several minutes"></p>
   </div>
</div>
    
</body>
</html>
<!-- [QPRTemplateEnd: impactanalysis.tpl] -->